Trap3d Posted September 10 Share Posted September 10 Hello everyone, I'm dealing with polylines with a lot of unnecessary steps, and normally i need to delete manually these edges. The goal is to have a lisp code that delete these edges, if the step value is 1.5mm. I tried PLDiet lisp code but the resulting pline cannot have diagonal lines, only horizontal or vertical. How can I proceed to solve this issue? Is already any code available for that? Thanks in advance for your tips! (PS: see attached file with an example). Example.dwg Quote Link to comment Share on other sites More sharing options...
exceed Posted September 11 Share Posted September 11 (edited) Before writing a routine, you must check that the conditions are logically flawless. From the length between polyline nodes, we need to distinguish between lines to be taken and lines not to be taken. Once the loop is run once, these two white lines in the example must survive. Since the rule is not grid snap 1.5 because the result's nodes do not fall to 1.5, deleting the right line must be done by looping once more with the result of the first loop. The left white line will survive though. Since the general routine makes judgments by comparing the front and back points, a new routine may be needed to estimate the edges using extension lines at the nodes at both ends. Extract the coordinates of each point of the polyline, first extract the cases where both sides are 1.5 or more from the length of the line segment (points marked with a 1.5 radius circle), and then draw only one side. After marking the point (marked by x) that is greater than 1.5, then draw a line first when there are continuous circles, draw directly towards the next point x on the circle. Now, we need to find the included angle in all coordinates other than 0 90 180 270 and remove that node. You also need to decide which side of the line to align it with. This is the guessing based on only the nodes, but if there is a condition that the area should not be modified in a way that makes it smaller, your example can be valid. In this case, you must add a routine to determine the area of the closed area and a routine to determine whether a point is inside or outside the closed polyline. It will become more complicated than guessing based on just the nodes. Edited September 11 by exceed 2 Quote Link to comment Share on other sites More sharing options...
lrm Posted September 11 Share Posted September 11 Here's an approach that might have some potential although there are a few coding challenges. Using offset, create an offset shape 1.5 mm outside the original shape. Delete all the fillets and replace them with chamfers. Note that if a fillet arc is not between a vertical and horizontal line then both the arc and the line "inside" should be deleted. Chamfer the resulting lines. Now construct an offset curve of 1.5 inside this shape. Replace the arcs with fillets and you have the desired end product! The most challenging coding part of this approach is determining which line segments should be deleted after the initial offset shape (i.e., the inside lines). 1 Quote Link to comment Share on other sites More sharing options...
BIGAL Posted September 11 Share Posted September 11 (edited) That is a hard shape to change, explode, fillet and erase comes to mind as 1st answer. Ok 2nd answer select pline segments in sequence, no arcs, then make a new pline from new line segments. So try this. Just pick segments press enter to stop picking it will close automatically. You must pick in order. (defun getplineseg (elst / elst ename pt param preparam postparam) (setq ename (car elst)) (setq pt (cadr elst)) (setq pt (vlax-curve-getClosestPointTo ename pt)) (print (setq param (vlax-curve-getParamAtPoint ename pt)) ) (print (setq preparam (fix param)) ) (print (setq postparam (1+ preparam)) ) (setq pt1 (vlax-curve-getPointAtParam ename preparam) pt2 (vlax-curve-getPointAtParam ename postparam)) ) (defun c:wow ( / oldsnap ent mp1 mp2 pt1 pt2 mpst) (setq oldsnap (getvar 'osmode)) (setvar 'osmode 0) (setvar 'filletrad 0.0) (setq ent (entsel "\nSelect pline segment: ")) (getplineseg ent) (command "pline" pt1 pt2 "") (setq mp1 (mapcar '* (mapcar '+ pt1 pt2) '(0.5 0.5))) (setq mpst mp1) (while (setq ent (entsel "\nSelect pline segment: ")) (getplineseg ent) (command "pline" pt1 pt2 "") (setq mp2 (mapcar '* (mapcar '+ pt1 pt2) '(0.5 0.5))) (command "fillet" mp1 mp2) (setq mp1 mp2) ) (setq obj (vlax-ename->vla-object (entlast))) (vlax-put obj 'Closed -1) (princ) ) Edited September 11 by BIGAL 2 Quote Link to comment Share on other sites More sharing options...
Trap3d Posted September 12 Author Share Posted September 12 Thank you all for your tips! @BIGAL@lrm@exceed @BIGAL your code works Thanks a lot. On most of my drawings i have dozens of edges to manually change. Your code needs always a manual input. Do you think that with your approach is possible to apply this code to all closed plines on the drawing without manual input? Thanks in advance. Quote Link to comment Share on other sites More sharing options...
BIGAL Posted September 12 Share Posted September 12 The shapes maybe to complex to put a rule about what to do. Is 8 seconds to much out of your day ? 1 Quote Link to comment Share on other sites More sharing options...
Trap3d Posted September 13 Author Share Posted September 13 Yeah you should be right about that. Well, your code is already a good way to speed things up Quote Link to comment Share on other sites More sharing options...
exceed Posted September 15 Share Posted September 15 (edited) ; DentRepair - 2023.09.15 exceeds ; Dent repairs polyline segments with vertical and horizontal outlines outwards. ; If the length of one line segment is less than a certain value, it adjusted out to a wider side. (defun c:DentRepair ( / *error* acdoc ss ssl index ent obj clist cllen isclosed index2 p0 p1 p2 p3 linelength lineangle setlength tempclist1 tempclist2 temp1 temp2 temp1obj temp2obj temp1area temp2area stopper resultent ) (vl-load-com) (defun *error* (msg) (if (/= msg "Function cancelled") (princ (strcat "\nError: " msg)) ) (vla-EndUndoMark acdoc) (princ) ) ;; Group by Number - Lee Mac ;; Groups a list 'l' into a list of lists, each of max length 'n' (defun LM:group<n ( l n ) (if l (LM:group<n-sub (cons nil l) n n)) ) (defun LM:group<n-sub ( l m n ) (if (and (cdr l) (< 0 n)) (LM:group<n-sub (cons (cons (cadr l) (car l)) (cddr l)) m (1- n)) (cons (reverse (car l)) (LM:group<n (cdr l) m)) ) ) ;;---------------------=={ Subst Nth }==----------------------;; ;; ;; ;; Substitutes an item at the nth position in a list. ;; ;;------------------------------------------------------------;; ;; Author: Lee Mac, Copyright © 2011 - www.lee-mac.com ;; ;;------------------------------------------------------------;; ;; Arguments: ;; ;; a - item to substitute ;; ;; n - position in list to make the substitution ;; ;; l - list in which to make the substitution ;; ;;------------------------------------------------------------;; ;; Returns: Resultant list following the substitution ;; ;;------------------------------------------------------------;; (defun LM:SubstNth ( a n l ) (if l (if (zerop n) (cons a (cdr l)) (cons (car l) (LM:SubstNth a (1- n) (cdr l))) ) ) ) ;; Unique - Lee Mac ;; Returns a list with duplicate elements removed. (defun LM:Unique ( l ) (if l (cons (car l) (LM:Unique (vl-remove (car l) (cdr l))))) ) ; degree to radian (defun dtr (a) (setq x (* pi (/ a 180.0))) ) ; radian to degree (defun rtd (a) (setq x (/ (* a 180) pi)) ) (defun lwpolybylist (lst cls) (entmakex (append (list (cons 0 "LWPOLYLINE") (cons 100 "AcDbEntity") (cons 100 "AcDbPolyline") (cons 90 (length lst)) (cons 70 cls) ) (mapcar (function (lambda (p) (cons 10 p))) lst) ) ) ) (setq acdoc (vla-get-ActiveDocument (vlax-get-ACAD-Object))) (vla-StartUndoMark acdoc) (setq setlength (getreal "\n Input Minimum Segment Value (Space Bar = 1.5): ")) ; can edit this value (if (= setlength nil) (setq setlength 1.5) (setq setlength (abs setlength)) ) (setq ss (ssget '((0 . "LWPOLYLINE")))) (setq ssl (sslength ss)) (setq index 0) (repeat ssl (setq ent (ssname ss index)) (setq obj (vlax-ename->vla-object ent)) (setq clist (vlax-safearray->list (vlax-variant-value (vlax-get-property obj 'coordinates)))) (setq cllen (length clist)) (setq isclosed (vlax-get-property obj 'closed)) ;(princ "\n isclosed? ") ;(princ isclosed) (if (= isclosed :vlax-true) (progn (setq clist (append clist (list (car clist) (cadr clist)))) ) (progn (if (and (= (car clist) (nth (- cllen 2) clist)) (= (cadr clist) (nth (- cllen 1) clist))) (progn) (progn (setq clist (append clist (list (car clist) (cadr clist)))) ) ) ) ) (setq clist (lm:unique (lm:group<n clist 2))) ;(princ "\n clist - ") ;(princ clist) (setq cllen (length clist)) (setq index2 0) (if (>= cllen 4) (progn (repeat cllen (if (and (/= index2 0) (/= resultent nil)) (entdel resultent) ) (setq p1 (nth index2 clist)) (if (= (- cllen 1) index2) (setq p2 (nth 0 clist)) (setq p2 (nth (+ index2 1) clist)) ) (if (= index2 0) (setq p0 (last clist)) (setq p0 (nth (- index2 1) clist)) ) (if (<= index2 (- cllen 3)) (setq p3 (nth (+ index2 2) clist)) (setq p3 (nth (- (+ index2 2) cllen) clist)) ) (setq linelength (distance p1 p2)) ;(princ "\n linelength - ") ;(princ linelength) (setq lineangle (rtd (angle p1 p2))) ;(princ "\n lineangle - ") ;(princ lineangle) (setq tempclist1 '()) (setq tempclist2 '()) (if (>= linelength setlength) (progn ;(if (or (= lineangle 0) (= lineangle 90) (= lineangle 180) (= lineangle 270) (= lineangle 360)) ; (progn) ; (progn) ;) ) (progn (cond ((or (= (rtos lineangle 2 0) "0") (= (rtos lineangle 2 0) "180")) ;horizontal line (setq tempclist1 (LM:SubstNth (list (car p1) (cadr p0)) index2 clist)) (setq tempclist1 (LM:SubstNth (list (car p2) (cadr p0)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist1)) (setq tempclist2 (LM:SubstNth (list (car p1) (cadr p3)) index2 clist)) (setq tempclist2 (LM:SubstNth (list (car p2) (cadr p3)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist2)) ) ((or (= (rtos lineangle 2 0) "90") (= (rtos lineangle 2 0) "270") (= (rtos lineangle 2 0) "360")) ;verical line (setq tempclist1 (LM:SubstNth (list (car p0) (cadr p1)) index2 clist)) (setq tempclist1 (LM:SubstNth (list (car p0) (cadr p2)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist1)) (setq tempclist2 (LM:SubstNth (list (car p3) (cadr p1)) index2 clist)) (setq tempclist2 (LM:SubstNth (list (car p3) (cadr p2)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist2)) ) (t (setq tempclist1 clist) (setq tempclist2 clist) ) ) ;(princ "\n tempclist1 - ") ;(princ tempclist1) (setq temp1 (lwpolybylist tempclist1 1)) ;(princ "\n tempclist2 - ") ;(princ tempclist2) (setq temp2 (lwpolybylist tempclist2 1)) (setq temp1obj (vlax-ename->vla-object temp1)) (setq temp2obj (vlax-ename->vla-object temp2)) (setq temp1area (vla-get-area temp1obj)) (setq temp2area (vla-get-area temp2obj)) (if (>= temp1area temp2area) (setq clist tempclist1) (setq clist tempclist2) ) (entdel temp1) (entdel temp2) ) ) (setq resultent (lwpolybylist clist 1)) ;(setq stopper (getstring "\n continue ? : ")) ;(princ "\n index2 - ") ;(princ index2) ;(princ " / cllen - ") ;(princ cllen) (setq index2 (+ index2 1)) ) ) (progn (princ "\n not enough vertices. (less then 4)") ) ) ;(setq stopper (getstring "\n continue ? : ")) (setq index (+ index 1)) ) (vla-EndUndoMark acdoc) (princ) ) You can start with this. command : DENTREPAIR Below GIF is for example (with pauses to show the calculation step by step) + This isn't a perfect solution. The steps in this routine are... 1. Measure the length of each line segment of the polyline. 2. If it is less than the set value (=1.5), 3. determine whether the line segment is vertical or horizontal, 4. Get the X (for a vertical line) or Y (for a horizontal line) value of both nodes adjacent to the line segment. 5. Replace the values in the original coordinate list 6. After creating each polyline, Compare each area and select the larger one. 7. Repeat this by looping each line segment. It is useful when there is a large fixed outline with small cracks, but the leakage point of this logic is if it is sharp, that part can be omitted. -> sharp means If there is a line segment that protrudes to the outermost edge with a value smaller than the entered value of 1.5 This is because the two neighboring points of this sharp point are located in a direction where the area is smaller than the original outline. In that case, the original point should be included in the comparison to find the one with the largest area among the 3 cases. If the original wins, this case is difficult, picked line segment is not modified, but both neighboring points need to be modified. It is difficult to solve this problem by simply running a forward loop. Even after modifying the neighboring points on both sides, need to check whether the rules are correct retrieve the coordinate list again, and the node numbers may also be messed up. Of course, this may be difficult only for me. Because there are many smart people. so I created a routine to create a new line above it. not modifying original line. It would be better to check manually. Edited September 15 by exceed 2 Quote Link to comment Share on other sites More sharing options...
Trap3d Posted Saturday at 09:06 AM Author Share Posted Saturday at 09:06 AM Thanks a lot @exceed! Its really what I was looking for. Sorry for late response, I was on holidays Your code works for most of the cases I have. Only one issue that i found out. If the first point of the output has different x and y coordinates comparing to the last one, the last segment that joins both points will have diagonal orientation. There is a way to make sure that all segments in the end are either horizontal or vertical? Usually i have almost an hundred of lines to change. Thanks in advance (See .dwg bellow with examples of shapes that have one diagonal segment after running de code) example.dwg Quote Link to comment Share on other sites More sharing options...
marko_ribar Posted Monday at 07:01 PM Share Posted Monday at 07:01 PM See if this topic can help you... It seems that doesn't, but imagine that you had more LWPOLYs and you wanted to join them... Then this would be full hit... https://www.cadtutor.net/forum/topic/63954-lisp-to-create-a-boundary-around-blocks-that-are-not-touching Quote Link to comment Share on other sites More sharing options...
marko_ribar Posted Monday at 07:41 PM Share Posted Monday at 07:41 PM (edited) @exceed Sorry for stealing your code, I just made quick fix, as OP wasn't satisfied... ; DentRepair - 2023.09.15 exceeds ; Dent repairs polyline segments with vertical and horizontal outlines outwards. ; If the length of one line segment is less than a certain value, it adjusted out to a wider side. (defun c:DentRepair ( / *error* LM:group<n LM:group<n-sub LM:SubstNth LM:Unique dtr rtd lwpolybylist acdoc ss ssl index ent obj clist cllen isclosed index2 p0 p1 p2 p3 linelength lineangle setlength tempclist1 tempclist2 temp1 temp2 temp1obj temp2obj temp1area temp2area stopper resultent clistx ) (vl-load-com) (defun *error* (msg) (if (/= msg "Function cancelled") (princ (strcat "\nError: " msg)) ) (vla-EndUndoMark acdoc) (princ) ) ;; Group by Number - Lee Mac ;; Groups a list 'l' into a list of lists, each of max length 'n' (defun LM:group<n ( l n ) (if l (LM:group<n-sub (cons nil l) n n)) ) (defun LM:group<n-sub ( l m n ) (if (and (cdr l) (< 0 n)) (LM:group<n-sub (cons (cons (cadr l) (car l)) (cddr l)) m (1- n)) (cons (reverse (car l)) (LM:group<n (cdr l) m)) ) ) ;;---------------------=={ Subst Nth }==----------------------;; ;; ;; ;; Substitutes an item at the nth position in a list. ;; ;;------------------------------------------------------------;; ;; Author: Lee Mac, Copyright © 2011 - www.lee-mac.com ;; ;;------------------------------------------------------------;; ;; Arguments: ;; ;; a - item to substitute ;; ;; n - position in list to make the substitution ;; ;; l - list in which to make the substitution ;; ;;------------------------------------------------------------;; ;; Returns: Resultant list following the substitution ;; ;;------------------------------------------------------------;; (defun LM:SubstNth ( a n l ) (if l (if (zerop n) (cons a (cdr l)) (cons (car l) (LM:SubstNth a (1- n) (cdr l))) ) ) ) ;; Unique - Lee Mac ;; Returns a list with duplicate elements removed. (defun LM:Unique ( l ) (if l (cons (car l) (LM:Unique (vl-remove (car l) (cdr l))))) ) ; degree to radian (defun dtr (a) (setq x (* pi (/ a 180.0))) ) ; radian to degree (defun rtd (a) (setq x (/ (* a 180) pi)) ) (defun lwpolybylist (lst cls) (entmakex (append (list (cons 0 "LWPOLYLINE") (cons 100 "AcDbEntity") (cons 100 "AcDbPolyline") (cons 90 (length lst)) (cons 70 cls) ) (mapcar (function (lambda (p) (cons 10 p))) lst) ) ) ) (setq acdoc (vla-get-ActiveDocument (vlax-get-ACAD-Object))) (vla-StartUndoMark acdoc) (setq setlength (getreal "\n Input Minimum Segment Value (Space Bar = 1.5): ")) ; can edit this value (if (= setlength nil) (setq setlength 1.5) (setq setlength (abs setlength)) ) (setq ss (ssget '((0 . "LWPOLYLINE")))) (setq ssl (sslength ss)) (setq index 0) (repeat ssl (setq ent (ssname ss index)) (setq obj (vlax-ename->vla-object ent)) (setq clist (vlax-safearray->list (vlax-variant-value (vlax-get-property obj 'coordinates)))) (setq cllen (length clist)) (setq isclosed (vlax-get-property obj 'closed)) ;(princ "\n isclosed? ") ;(princ isclosed) (if (= isclosed :vlax-true) (setq clist (append clist (list (car clist) (cadr clist)))) (progn (if (and (= (car clist) (nth (- cllen 2) clist)) (= (cadr clist) (nth (- cllen 1) clist))) (progn) (setq clist (append clist (list (car clist) (cadr clist)))) ) ) ) (setq clist (lm:unique (lm:group<n clist 2))) ;(princ "\n clist - ") ;(princ clist) (setq cllen (length clist)) (setq index2 0) (if (>= cllen 4) (progn (repeat cllen (if (and (/= index2 0) (/= resultent nil)) (entdel resultent) ) (setq p1 (nth index2 clist)) (if (= (- cllen 1) index2) (setq p2 (nth 0 clist)) (setq p2 (nth (+ index2 1) clist)) ) (if (= index2 0) (setq p0 (last clist)) (setq p0 (nth (- index2 1) clist)) ) (if (<= index2 (- cllen 3)) (setq p3 (nth (+ index2 2) clist)) (setq p3 (nth (- (+ index2 2) cllen) clist)) ) (setq linelength (distance p1 p2)) ;(princ "\n linelength - ") ;(princ linelength) (setq lineangle (rtd (angle p1 p2))) ;(princ "\n lineangle - ") ;(princ lineangle) (setq tempclist1 '()) (setq tempclist2 '()) (if (>= linelength setlength) (progn ;(if (or (= lineangle 0) (= lineangle 90) (= lineangle 180) (= lineangle 270) (= lineangle 360)) ; (progn) ; (progn) ;) ) (progn (cond ((or (= (rtos lineangle 2 0) "0") (= (rtos lineangle 2 0) "180") (= (rtos lineangle 2 0) "360")) ;horizontal line (setq tempclist1 (LM:SubstNth (list (car p1) (cadr p0)) index2 clist)) (setq tempclist1 (LM:SubstNth (list (car p2) (cadr p0)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist1)) (setq tempclist2 (LM:SubstNth (list (car p1) (cadr p3)) index2 clist)) (setq tempclist2 (LM:SubstNth (list (car p2) (cadr p3)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist2)) ) ((or (= (rtos lineangle 2 0) "90") (= (rtos lineangle 2 0) "270")) ;verical line (setq tempclist1 (LM:SubstNth (list (car p0) (cadr p1)) index2 clist)) (setq tempclist1 (LM:SubstNth (list (car p0) (cadr p2)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist1)) (setq tempclist2 (LM:SubstNth (list (car p3) (cadr p1)) index2 clist)) (setq tempclist2 (LM:SubstNth (list (car p3) (cadr p2)) (if (= (- cllen 1) index) 0 (+ index2 1)) tempclist2)) ) (t (setq tempclist1 clist) (setq tempclist2 clist) ) ) ;(princ "\n tempclist1 - ") ;(princ tempclist1) (setq temp1 (lwpolybylist tempclist1 1)) ;(princ "\n tempclist2 - ") ;(princ tempclist2) (setq temp2 (lwpolybylist tempclist2 1)) (setq temp1obj (vlax-ename->vla-object temp1)) (setq temp2obj (vlax-ename->vla-object temp2)) (setq temp1area (vla-get-area temp1obj)) (setq temp2area (vla-get-area temp2obj)) (if (>= temp1area temp2area) (setq clist tempclist1) (setq clist tempclist2) ) (entdel temp1) (entdel temp2) ) ) ;(setq stopper (getstring "\n continue ? : ")) ;(princ "\n index2 - ") ;(princ index2) ;(princ " / cllen - ") ;(princ cllen) (setq index2 (+ index2 1)) ) ) (progn (princ "\n not enough vertices. (less then 4)") ) ) ;(setq stopper (getstring "\n continue ? : ")) (setq index (+ index 1)) ) (setq clist (LM:Unique clist)) (if (vl-some '(lambda ( a b ) (not (or (equal (angle a b) (* 0.0 pi) 1e-8) (equal (angle a b) (* 0.5 pi) 1e-8) (equal (angle a b) (* 1.0 pi) 1e-8) (equal (angle a b) (* 1.5 pi) 1e-8) (equal (angle a b) (* 2.0 pi) 1e-8)))) (append clist clist) (append (cdr clist) (list (car clist)) (cdr clist) (list (car clist)))) (progn (setq clistx (vl-remove (last clist) clist)) (if (vl-some '(lambda ( a b ) (not (or (equal (angle a b) (* 0.0 pi) 1e-8) (equal (angle a b) (* 0.5 pi) 1e-8) (equal (angle a b) (* 1.0 pi) 1e-8) (equal (angle a b) (* 1.5 pi) 1e-8) (equal (angle a b) (* 2.0 pi) 1e-8)))) (append clistx clistx) (append (cdr clistx) (list (car clistx)) (cdr clistx) (list (car clistx)))) (setq clistx (cdr clist)) ) ) ) (if clistx (setq resultent (lwpolybylist clistx 1)) (setq resultent (lwpolybylist clist 1)) ) (vla-EndUndoMark acdoc) (princ) ) HTH. M.R. Edited 7 hours ago by marko_ribar Quote Link to comment Share on other sites More sharing options...
Recommended Posts
Join the conversation
You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.